// Testing...

#include <gpiod.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>

#ifndef CONSUMER
#define CONSUMER        "Consumer"
#endif

int main(int argc, char **argv)
{
        char *chipname0 = "gpiochip0";	// figure out which chips are needed...
        char *chipname1 = "gpiochip1";
        char *chipname2 = "gpiochip2";

        unsigned int line_num1 = 17;    // Direction
        unsigned int line_num2 = 27;    // Step
        unsigned int line_num3 = 22;    // Enable

        unsigned int val;

        struct gpiod_chip *chip0;
        struct gpiod_chip *chip1;
        struct gpiod_chip *chip2;

        struct gpiod_line *line1;
        struct gpiod_line *line2;
        struct gpiod_line *line3;

        int i, ret1, ret2, ret3;

        chip0 = gpiod_chip_open_by_name(chipname0);
        if (!chip0) {
                perror("Open chip failed\n");
                goto end;
        }

        chip1 = gpiod_chip_open_by_name(chipname1);
        if (!chip1) {
                perror("The opening is failing...\n");
                goto end;
        }

        chip2 = gpiod_chip_open_by_name(chipname2);
        if (!chip2) {
                perror("Cannot open this chip...\n");
                goto end;
        }

        line1 = gpiod_chip_get_line(chip2, line_num1);
        if (!line1) {
                perror("Get line failed\n");
                goto close_chip;
        }

        line2 = gpiod_chip_get_line(chip1, line_num2);
        if (!line2) {
                perror("Get line failed\n");
                goto close_chip;
        }

        line3 = gpiod_chip_get_line(chip1, line_num3);
        if (!line3) {
                perror("Get line failed\n");
                goto close_chip;
        }

        ret1 = gpiod_line_request_output(line1, CONSUMER, 0);
        if (ret1 < 0) {
                perror("Request line as output failed\n");
                goto release_line;
        }

        ret2 = gpiod_line_request_output(line2, CONSUMER, 0);
        if (ret2 < 0) {
                perror("Request line as output failed\n");
                goto release_line;
        }

        ret3 = gpiod_line_request_output(line3, CONSUMER, 0);
        if (ret3 < 0) {
                perror("Request line as output failed\n");
                goto release_line;
        }

        /* Blink 20 times */
        val = 0;

        for (i = 20; i > 0; i--) {
                ret1 = gpiod_line_set_value(line1, 1);
                if (ret1 < 0) {
                        perror("Set line output failed\n");
                        goto release_line;
                }
                printf("Output %u on line #%u\n", val, line_num1);
                sleep(2);
                val = !val;

                        ret3 = gpiod_line_set_value(line3, val);
                        val = 1;
                        sleep(1);

                        ret2 = gpiod_line_set_value(line2, val);
                        if (ret2 < 0) {
                                perror("Cancellation in progress...\n");
                                goto release_line;
                        }
                printf("Output %u on line #%u\n", val, line_num2);
                sleep(2);
                val = !val;

                if (val = !val) {
                        ret3 = gpiod_line_set_value(line3, 1);
                        ret2 = gpiod_line_set_value(line2, 1/8);
                        ret1 = gpiod_line_set_value(line1, 0);
                        sleep(2);

                        ret3 = gpiod_line_set_value(line3, 1);
                        ret2 = gpiod_line_set_value(line2, 1/8);
                        ret1 = gpiod_line_set_value(line1, 1);
                        sleep(2);

                }

                else {
                        goto end;
                }
        }

release_line:
        gpiod_line_release(line3);
close_chip:
        gpiod_chip_close(chip1);
end:
        return 0;
}